package protocol

// ----------------------------------------------------------------------------
// Codec
// ----------------------------------------------------------------------------
// RegistryCodec creates a RegistryCodecRequest to process each request.
type RegistryCodec interface {
	// Reads the request and returns the RPC method name.
	Method() string
	// Reads the request filling the RPC method args.
	ReadParams(args []interface{}) error
	Params() ([]string, error)

	HasResponse() bool
}
